diff --git a/gcc/postreload.c b/gcc/postreload.c
index 9bfffe5..520fbe2 100644
--- a/gcc/postreload.c
+++ b/gcc/postreload.c
@@ -68,7 +68,7 @@ reload_cse_regs (rtx first ATTRIBUTE_UNUSED)
   reload_cse_regs_1 ();
   reload_combine ();
   moves_converted = reload_cse_move2add (first);
-  if (flag_expensive_optimizations)
+  if (GCC_OPTION (flag_expensive_optimizations))
     {
       if (moves_converted)
 	reload_combine ();
@@ -2318,7 +2318,7 @@ move2add_note_store (rtx dst, const_rtx set, void *data)
 static bool
 gate_handle_postreload (void)
 {
-  return (optimize > 0 && reload_completed);
+  return (GCC_OPTION (optimize) > 0 && reload_completed);
 }
 
 
diff --git a/gcc/predict.c b/gcc/predict.c
index 249433f..cbfb9c0 100644
--- a/gcc/predict.c
+++ b/gcc/predict.c
@@ -114,7 +114,7 @@ static inline bool
 maybe_hot_frequency_p (struct function *fun, int freq)
 {
   struct cgraph_node *node = cgraph_get_node (fun->decl);
-  if (!profile_info || !flag_branch_probabilities)
+  if (!profile_info || !GCC_OPTION (flag_branch_probabilities))
     {
       if (node->frequency == NODE_FREQUENCY_UNLIKELY_EXECUTED)
         return false;
@@ -189,7 +189,7 @@ maybe_hot_bb_p (struct function *fun, const_basic_block bb)
 bool
 cgraph_maybe_hot_edge_p (struct cgraph_edge *edge)
 {
-  if (profile_info && flag_branch_probabilities
+  if (profile_info && GCC_OPTION (flag_branch_probabilities)
       && !maybe_hot_count_p (NULL,
                              edge->count))
     return false;
@@ -201,14 +201,14 @@ cgraph_maybe_hot_edge_p (struct cgraph_edge *edge)
       && (edge->callee
 	  && edge->callee->frequency <= NODE_FREQUENCY_EXECUTED_ONCE))
     return false;
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return false;
   if (edge->caller->frequency == NODE_FREQUENCY_HOT)
     return true;
   if (edge->caller->frequency == NODE_FREQUENCY_EXECUTED_ONCE
       && edge->frequency < CGRAPH_FREQ_BASE * 3 / 2)
     return false;
-  if (flag_guess_branch_prob)
+  if (GCC_OPTION (flag_guess_branch_prob))
     {
       if (PARAM_VALUE (HOT_BB_FREQUENCY_FRACTION) == 0
 	  || edge->frequency <= (CGRAPH_FREQ_BASE
@@ -274,7 +274,7 @@ probably_never_executed (struct function *fun,
 	}
       return true;
     }
-  if ((!profile_info || !flag_branch_probabilities)
+  if ((!profile_info || !GCC_OPTION (flag_branch_probabilities))
       && (cgraph_get_node (fun->decl)->frequency
 	  == NODE_FREQUENCY_UNLIKELY_EXECUTED))
     return true;
@@ -304,7 +304,7 @@ probably_never_executed_edge_p (struct function *fun, edge e)
 bool
 cgraph_optimize_for_size_p (struct cgraph_node *node)
 {
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return true;
   if (node && (node->frequency == NODE_FREQUENCY_UNLIKELY_EXECUTED))
     return true;
@@ -317,7 +317,7 @@ cgraph_optimize_for_size_p (struct cgraph_node *node)
 bool
 optimize_function_for_size_p (struct function *fun)
 {
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return true;
   if (!fun || !fun->decl)
     return false;
@@ -563,7 +563,7 @@ static void
 predict_insn (rtx insn, enum br_predictor predictor, int probability)
 {
   gcc_assert (any_condjump_p (insn));
-  if (!flag_guess_branch_prob)
+  if (!GCC_OPTION (flag_guess_branch_prob))
     return;
 
   add_reg_note (insn, REG_BR_PRED,
@@ -613,7 +613,7 @@ gimple_predict_edge (edge e, enum br_predictor predictor, int probability)
   gcc_assert (profile_status_for_fn (cfun) != PROFILE_GUESSED);
   if ((e->src != ENTRY_BLOCK_PTR_FOR_FN (cfun) && EDGE_COUNT (e->src->succs) >
        1)
-      && flag_guess_branch_prob && optimize)
+      && GCC_OPTION (flag_guess_branch_prob) && GCC_OPTION (optimize))
     {
       struct edge_prediction *i = XNEW (struct edge_prediction);
       void **preds = pointer_map_insert (bb_predictions, e->src);
@@ -2846,7 +2846,7 @@ drop_profile (struct cgraph_node *node, gcov_type call_count)
   if (!DECL_COMDAT (node->decl) && !DECL_EXTERNAL (node->decl)
       && call_count > profile_info->runs)
     {
-      if (flag_profile_correction)
+      if (GCC_OPTION (flag_profile_correction))
         {
           if (dump_file)
             fprintf (dump_file,
@@ -2859,7 +2859,7 @@ drop_profile (struct cgraph_node *node, gcov_type call_count)
     }
 
   profile_status_for_fn (fn)
-      = (flag_guess_branch_prob ? PROFILE_GUESSED : PROFILE_ABSENT);
+      = (GCC_OPTION (flag_guess_branch_prob) ? PROFILE_GUESSED : PROFILE_ABSENT);
   node->frequency
       = hot ? NODE_FREQUENCY_HOT : NODE_FREQUENCY_NORMAL;
 }
@@ -3134,7 +3134,7 @@ compute_function_frequency (void)
 static bool
 gate_estimate_probability (void)
 {
-  return flag_guess_branch_prob;
+  return GCC_OPTION (flag_guess_branch_prob);
 }
 
 /* Build PREDICT_EXPR.  */
diff --git a/gcc/print-rtl.c b/gcc/print-rtl.c
index 09ac387..b77cd99 100644
--- a/gcc/print-rtl.c
+++ b/gcc/print-rtl.c
@@ -240,7 +240,7 @@ print_rtx (const_rtx in_rtx)
 	      {
 	      case NOTE_INSN_EH_REGION_BEG:
 	      case NOTE_INSN_EH_REGION_END:
-		if (flag_dump_unnumbered)
+		if (GCC_OPTION (flag_dump_unnumbered))
 		  fprintf (outfile, " #");
 		else
 		  fprintf (outfile, " %d", NOTE_EH_HANDLER (in_rtx));
@@ -485,7 +485,7 @@ print_rtx (const_rtx in_rtx)
 	      }
 	    else
 #endif
-	      if (flag_dump_unnumbered
+	      if (GCC_OPTION (flag_dump_unnumbered)
 		     && (is_insn || NOTE_P (in_rtx)))
 	      fputc ('#', outfile);
 	    else
@@ -533,7 +533,7 @@ print_rtx (const_rtx in_rtx)
 		if (subc == NOTE
 		    && NOTE_KIND (sub) == NOTE_INSN_DELETED_LABEL)
 		  {
-		    if (flag_dump_unnumbered)
+		    if (GCC_OPTION (flag_dump_unnumbered))
 		      fprintf (outfile, " [# deleted]");
 		    else
 		      fprintf (outfile, " [%d deleted]", INSN_UID (sub));
@@ -545,8 +545,8 @@ print_rtx (const_rtx in_rtx)
 		  goto do_e;
 	      }
 
-	    if (flag_dump_unnumbered
-		|| (flag_dump_unnumbered_links && (i == 1 || i == 2)
+	    if (GCC_OPTION (flag_dump_unnumbered)
+		|| (GCC_OPTION (flag_dump_unnumbered_links) && (i == 1 || i == 2)
 		    && (INSN_P (in_rtx) || NOTE_P (in_rtx)
 			|| LABEL_P (in_rtx) || BARRIER_P (in_rtx))))
 	      fputs (" #", outfile);
diff --git a/gcc/print-tree.c b/gcc/print-tree.c
index 91b696c..fa4d299 100644
--- a/gcc/print-tree.c
+++ b/gcc/print-tree.c
@@ -53,7 +53,7 @@ static struct bucket **table;
 void
 dump_addr (FILE *file, const char *prefix, const void *addr)
 {
-  if (flag_dump_noaddr || flag_dump_unnumbered)
+  if (GCC_OPTION (flag_dump_noaddr) || GCC_OPTION (flag_dump_unnumbered))
     fprintf (file, "%s#", prefix);
   else
     fprintf (file, "%s" HOST_PTR_PRINTF, prefix, addr);
diff --git a/gcc/profile.c b/gcc/profile.c
index 83cbc07..f2c3b43 100644
--- a/gcc/profile.c
+++ b/gcc/profile.c
@@ -447,7 +447,7 @@ read_profile_edge_counts (gcov_type *exec_counts)
 		e->count = exec_counts[exec_counts_pos++];
 		if (e->count > profile_info->sum_max)
 		  {
-		    if (flag_profile_correction)
+		    if (GCC_OPTION (flag_profile_correction))
 		      {
 			static bool informed = 0;
 			if (dump_enabled_p () && !informed)
@@ -702,7 +702,7 @@ compute_branch_probabilities (unsigned cfg_checksum, unsigned lineno_checksum)
 
   if (inconsistent)
    {
-     if (flag_profile_correction)
+     if (GCC_OPTION (flag_profile_correction))
        {
          /* Inconsistency detected. Make it flow-consistent. */
          static int informed = 0;
@@ -1293,20 +1293,20 @@ branch_prob (void)
 	}
     }
 
-  if (flag_profile_values)
+  if (GCC_OPTION (flag_profile_values))
     gimple_find_values_to_profile (&values);
 
-  if (flag_branch_probabilities)
+  if (GCC_OPTION (flag_branch_probabilities))
     {
       compute_branch_probabilities (cfg_checksum, lineno_checksum);
-      if (flag_profile_values)
+      if (GCC_OPTION (flag_profile_values))
 	compute_value_histograms (values, cfg_checksum, lineno_checksum);
     }
 
   remove_fake_edges ();
 
   /* For each edge not on the spanning tree, add counting code.  */
-  if (profile_arc_flag
+  if (GCC_OPTION (profile_arc_flag)
       && coverage_counter_alloc (GCOV_COUNTER_ARCS, num_instrumented))
     {
       unsigned n_instrumented;
@@ -1317,7 +1317,7 @@ branch_prob (void)
 
       gcc_assert (n_instrumented == num_instrumented);
 
-      if (flag_profile_values)
+      if (GCC_OPTION (flag_profile_values))
 	instrument_values (values);
 
       /* Commit changes done by instrumentation.  */
diff --git a/gcc/real.h b/gcc/real.h
index ff0c523..213dde8 100644
--- a/gcc/real.h
+++ b/gcc/real.h
@@ -198,25 +198,25 @@ extern const struct real_format *
    disabled for modes with NaNs.  The user can ask for them to be
    done anyway using the -funsafe-math-optimizations switch.  */
 #define HONOR_NANS(MODE) \
-  (MODE_HAS_NANS (MODE) && !flag_finite_math_only)
+  (MODE_HAS_NANS (MODE) && !GCC_OPTION (flag_finite_math_only))
 
 /* Like HONOR_NANs, but true if we honor signaling NaNs (or sNaNs).  */
-#define HONOR_SNANS(MODE) (flag_signaling_nans && HONOR_NANS (MODE))
+#define HONOR_SNANS(MODE) (GCC_OPTION (flag_signaling_nans) && HONOR_NANS (MODE))
 
 /* As for HONOR_NANS, but true if the mode can represent infinity and
    the treatment of infinite values is important.  */
 #define HONOR_INFINITIES(MODE) \
-  (MODE_HAS_INFINITIES (MODE) && !flag_finite_math_only)
+  (MODE_HAS_INFINITIES (MODE) && !GCC_OPTION (flag_finite_math_only))
 
 /* Like HONOR_NANS, but true if the given mode distinguishes between
    positive and negative zero, and the sign of zero is important.  */
 #define HONOR_SIGNED_ZEROS(MODE) \
-  (MODE_HAS_SIGNED_ZEROS (MODE) && flag_signed_zeros)
+  (MODE_HAS_SIGNED_ZEROS (MODE) && GCC_OPTION (flag_signed_zeros))
 
 /* Like HONOR_NANS, but true if given mode supports sign-dependent rounding,
    and the rounding mode is important.  */
 #define HONOR_SIGN_DEPENDENT_ROUNDING(MODE) \
-  (MODE_HAS_SIGN_DEPENDENT_ROUNDING (MODE) && flag_rounding_math)
+  (MODE_HAS_SIGN_DEPENDENT_ROUNDING (MODE) && GCC_OPTION (flag_rounding_math))
 
 /* Declare functions in real.c.  */
 
diff --git a/gcc/recog.c b/gcc/recog.c
index f9040dc..ec5c678 100644
--- a/gcc/recog.c
+++ b/gcc/recog.c
@@ -989,7 +989,7 @@ general_operand (rtx op, enum machine_mode mode)
   if (CONSTANT_P (op))
     return ((GET_MODE (op) == VOIDmode || GET_MODE (op) == mode
 	     || mode == VOIDmode)
-	    && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (op))
+	    && (! GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (op))
 	    && targetm.legitimate_constant_p (mode == VOIDmode
 					      ? GET_MODE (op)
 					      : mode, op));
@@ -1178,7 +1178,7 @@ immediate_operand (rtx op, enum machine_mode mode)
   return (CONSTANT_P (op)
 	  && (GET_MODE (op) == mode || mode == VOIDmode
 	      || GET_MODE (op) == VOIDmode)
-	  && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (op))
+	  && (! GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (op))
 	  && targetm.legitimate_constant_p (mode == VOIDmode
 					    ? GET_MODE (op)
 					    : mode, op));
@@ -1828,7 +1828,7 @@ asm_operand_ok (rtx op, const char *constraint, const char **constraints)
 	  /* Fall through.  */
 
 	case 'i':
-	  if (CONSTANT_P (op) && (! flag_pic || LEGITIMATE_PIC_OPERAND_P (op)))
+	  if (CONSTANT_P (op) && (! GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (op)))
 	    result = 1;
 	  break;
 
@@ -3852,7 +3852,7 @@ if_test_bypass_p (rtx out_insn, rtx in_insn)
 static bool
 gate_handle_peephole2 (void)
 {
-  return (optimize > 0 && flag_peephole2);
+  return (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_peephole2));
 }
 
 static unsigned int
@@ -3957,7 +3957,7 @@ rest_of_handle_split_after_reload (void)
 {
   /* If optimizing, then go ahead and split insns now.  */
 #ifndef STACK_REGS
-  if (optimize > 0)
+  if (GCC_OPTION (optimize) > 0)
 #endif
     split_all_insns ();
   return 0;
@@ -4009,9 +4009,9 @@ gate_handle_split_before_regstack (void)
      split until final which doesn't allow splitting
      if HAVE_ATTR_length.  */
 # ifdef INSN_SCHEDULING
-  return (optimize && !flag_schedule_insns_after_reload);
+  return (GCC_OPTION (optimize) && !GCC_OPTION (flag_schedule_insns_after_reload));
 # else
-  return (optimize);
+  return (GCC_OPTION (optimize));
 # endif
 #else
   return 0;
@@ -4069,7 +4069,7 @@ static bool
 gate_handle_split_before_sched2 (void)
 {
 #ifdef INSN_SCHEDULING
-  return optimize > 0 && flag_schedule_insns_after_reload;
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_schedule_insns_after_reload);
 #else
   return 0;
 #endif
diff --git a/gcc/ree.c b/gcc/ree.c
index fcde9a0..49dbc79 100644
--- a/gcc/ree.c
+++ b/gcc/ree.c
@@ -1098,7 +1098,7 @@ rest_of_handle_ree (void)
 static bool
 gate_handle_ree (void)
 {
-  return (optimize > 0 && flag_ree);
+  return (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_ree));
 }
 
 namespace {
diff --git a/gcc/reg-stack.c b/gcc/reg-stack.c
index a92830b..7fed2af 100644
--- a/gcc/reg-stack.c
+++ b/gcc/reg-stack.c
@@ -435,7 +435,7 @@ get_true_reg (rtx *pat)
 	return pat;
 
       case FLOAT_TRUNCATE:
-	if (!flag_unsafe_math_optimizations)
+	if (!GCC_OPTION (flag_unsafe_math_optimizations))
 	  return pat;
 	pat = & XEXP (*pat, 0);
 	break;
@@ -3260,8 +3260,8 @@ reg_to_stack (void)
      the PIC register hasn't been set up.  In that case, fall back
      on zero, which we can get from `fldz'.  */
 
-  if ((flag_pic && !TARGET_64BIT)
-      || ix86_cmodel == CM_LARGE || ix86_cmodel == CM_LARGE_PIC)
+  if ((GCC_OPTION (flag_pic) && !TARGET_64BIT)
+      || GCC_OPTION (ix86_cmodel) == CM_LARGE || GCC_OPTION (ix86_cmodel) == CM_LARGE_PIC)
     not_a_num = CONST0_RTX (SFmode);
   else
     {
diff --git a/gcc/regcprop.c b/gcc/regcprop.c
index 101de76..a7d621d 100644
--- a/gcc/regcprop.c
+++ b/gcc/regcprop.c
@@ -1250,7 +1250,7 @@ validate_value_data (struct value_data *vd)
 static bool
 gate_handle_cprop (void)
 {
-  return (optimize > 0 && (flag_cprop_registers));
+  return (GCC_OPTION (optimize) > 0 && (GCC_OPTION (flag_cprop_registers)));
 }
 
 
diff --git a/gcc/regrename.c b/gcc/regrename.c
index 6517f4e..30d990c 100644
--- a/gcc/regrename.c
+++ b/gcc/regrename.c
@@ -1839,7 +1839,7 @@ regrename_optimize (void)
 static bool
 gate_handle_regrename (void)
 {
-  return (optimize > 0 && (flag_rename_registers));
+  return (GCC_OPTION (optimize) > 0 && (GCC_OPTION (flag_rename_registers)));
 }
 
 namespace {
diff --git a/gcc/regs.h b/gcc/regs.h
index 006caca..1171ca5 100644
--- a/gcc/regs.h
+++ b/gcc/regs.h
@@ -135,8 +135,8 @@ extern size_t reg_info_p_size;
    or profile driven feedback is available and the function is never executed,
    frequency is always equivalent.  Otherwise rescale the basic block
    frequency.  */
-#define REG_FREQ_FROM_BB(bb) (optimize_size				      \
-			      || (flag_branch_probabilities		      \
+#define REG_FREQ_FROM_BB(bb) (GCC_OPTION (optimize_size)				      \
+			      || (GCC_OPTION (flag_branch_probabilities)		      \
 				  && !ENTRY_BLOCK_PTR_FOR_FN (cfun)->count)   \
 			      ? REG_FREQ_MAX				      \
 			      : ((bb)->frequency * REG_FREQ_MAX / BB_FREQ_MAX)\
diff --git a/gcc/reload.c b/gcc/reload.c
index 851daf3..ae53db5 100644
--- a/gcc/reload.c
+++ b/gcc/reload.c
@@ -3444,7 +3444,7 @@ find_reloads (rtx insn, int replace, int ind_levels, int live_known,
 		      break;
 		  case 'i':
 		    if (CONSTANT_P (operand)
-			&& (! flag_pic || LEGITIMATE_PIC_OPERAND_P (operand)))
+			&& (! GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (operand)))
 		      win = 1;
 		    break;
 
@@ -3479,7 +3479,7 @@ find_reloads (rtx insn, int replace, int ind_levels, int live_known,
 			/* A SCRATCH is not a valid operand.  */
 			&& GET_CODE (operand) != SCRATCH
 			&& (! CONSTANT_P (operand)
-			    || ! flag_pic
+			    || ! GCC_OPTION (flag_pic)
 			    || LEGITIMATE_PIC_OPERAND_P (operand))
 			&& (GENERAL_REGS == ALL_REGS
 			    || !REG_P (operand)
@@ -4146,7 +4146,7 @@ find_reloads (rtx insn, int replace, int ind_levels, int live_known,
     else if (goal_alternative_matched[i] < 0
 	     && goal_alternative_matches[i] < 0
 	     && address_operand_reloaded[i] != 1
-	     && optimize)
+	     && GCC_OPTION (optimize))
       {
 	/* For each non-matching operand that's a MEM or a pseudo-register
 	   that didn't get a hard register, make an optional reload.
@@ -4224,7 +4224,7 @@ find_reloads (rtx insn, int replace, int ind_levels, int live_known,
 	     && modified[i] == RELOAD_READ
 	     && modified[goal_alternative_matches[i]] == RELOAD_WRITE
 	     && ! no_input_reloads && ! no_output_reloads
-	     && optimize)
+	     && GCC_OPTION (optimize))
       {
 	/* Similarly, make an optional reload for a pair of matching
 	   objects that are in MEM or a pseudo that didn't get a hard reg.  */
@@ -6749,7 +6749,7 @@ find_equiv_reg (rtx goal, rtx insn, enum reg_class rclass, int other,
       enum rtx_code code = GET_CODE (XEXP (goal, 0));
       if (MEM_VOLATILE_P (goal))
 	return 0;
-      if (flag_float_store && SCALAR_FLOAT_MODE_P (GET_MODE (goal)))
+      if (GCC_OPTION (flag_float_store) && SCALAR_FLOAT_MODE_P (GET_MODE (goal)))
 	return 0;
       /* An address with side effects must be reexecuted.  */
       switch (code)
diff --git a/gcc/reload1.c b/gcc/reload1.c
index 3d735ee..6f98f26 100644
--- a/gcc/reload1.c
+++ b/gcc/reload1.c
@@ -607,7 +607,7 @@ has_nonexceptional_receiver (void)
   basic_block *tos, *worklist, bb;
 
   /* If we're not optimizing, then just err on the safe side.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return true;
 
   /* First determine which blocks can reach exit via normal paths.  */
@@ -1239,7 +1239,7 @@ reload (rtx first, int global)
 
   /* If we are doing generic stack checking, give a warning if this
      function's frame size is larger than we expect.  */
-  if (flag_stack_check == GENERIC_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK)
     {
       HOST_WIDE_INT size = get_frame_size () + STACK_CHECK_FIXED_FRAME_SIZE;
       static int verbose_warned = 0;
@@ -1509,7 +1509,7 @@ calculate_needs_all_insns (int global)
 	     We only do this when expensive_optimizations is enabled,
 	     since this complements reload inheritance / output
 	     reload deletion, and it can make debugging harder.  */
-	  if (flag_expensive_optimizations && n_reloads > 1)
+	  if (GCC_OPTION (flag_expensive_optimizations) && n_reloads > 1)
 	    {
 	      rtx set = single_set (insn);
 	      if (set
@@ -4176,7 +4176,7 @@ init_eliminable_invariants (rtx first, bool do_subregs)
 
 	  /* If flag_pic and we have constant, verify it's legitimate.  */
 	  if (!CONSTANT_P (x)
-	      || !flag_pic || LEGITIMATE_PIC_OPERAND_P (x))
+	      || !GCC_OPTION (flag_pic) || LEGITIMATE_PIC_OPERAND_P (x))
 	    {
 	      /* It can happen that a REG_EQUIV note contains a MEM
 		 that is not a legitimate memory operand.  As later
@@ -6476,7 +6476,7 @@ choose_reload_regs (struct insn_chain *chain)
      with fp on the 68k: fp numbers (not NaNs) fail to be equal to themselves
      because one side of the comparison might be inherited.  */
   win = 0;
-  for (inheritance = optimize > 0; inheritance >= 0; inheritance--)
+  for (inheritance = GCC_OPTION (optimize) > 0; inheritance >= 0; inheritance--)
     {
       choose_reload_regs_init (chain, save_reload_reg_rtx);
 
@@ -7010,7 +7010,7 @@ choose_reload_regs (struct insn_chain *chain)
   /* If doing expensive optimizations, do one preliminary pass that doesn't
      cancel any inheritance, but removes reloads that have been needed only
      for reloads that we know can be inherited.  */
-  for (pass = flag_expensive_optimizations; pass >= 0; pass--)
+  for (pass = GCC_OPTION (flag_expensive_optimizations); pass >= 0; pass--)
     {
       for (j = 0; j < n_reloads; j++)
 	{
@@ -7262,7 +7262,7 @@ emit_input_reload_insns (struct insn_chain *chain, struct reload *rl,
      with an output-reload, see if we can prove there was
      actually no need to store the old value in it.  */
 
-  if (optimize && REG_P (oldequiv)
+  if (GCC_OPTION (optimize) && REG_P (oldequiv)
       && REGNO (oldequiv) < FIRST_PSEUDO_REGISTER
       && spill_reg_store[REGNO (oldequiv)]
       && REG_P (old)
@@ -7339,7 +7339,7 @@ emit_input_reload_insns (struct insn_chain *chain, struct reload *rl,
      insn, see if we can get rid of that pseudo-register entirely
      by redirecting the previous insn into our reload register.  */
 
-  else if (optimize && REG_P (old)
+  else if (GCC_OPTION (optimize) && REG_P (old)
 	   && REGNO (old) >= FIRST_PSEUDO_REGISTER
 	   && dead_or_set_p (insn, old)
 	   /* This is unsafe if some other reload
@@ -7798,7 +7798,7 @@ emit_output_reload_insns (struct insn_chain *chain, struct reload *rl,
 
       /* Don't output the last reload if OLD is not the dest of
 	 INSN and is in the src and is clobbered by INSN.  */
-      if (! flag_expensive_optimizations
+      if (! GCC_OPTION (flag_expensive_optimizations)
 	  || !REG_P (old)
 	  || !(set = single_set (insn))
 	  || rtx_equal_p (old, SET_DEST (set))
@@ -7957,7 +7957,7 @@ do_input_reload (struct insn_chain *chain, struct reload *rl, int j)
   /* When inheriting a wider reload, we have a MEM in rl->in,
      e.g. inheriting a SImode output reload for
      (mem:HI (plus:SI (reg:SI 14 fp) (const_int 10)))  */
-  if (optimize && reload_inherited[j] && rl->in
+  if (GCC_OPTION (optimize) && reload_inherited[j] && rl->in
       && MEM_P (rl->in)
       && MEM_P (rl->in_reg)
       && reload_spill_index[j] >= 0
@@ -7968,7 +7968,7 @@ do_input_reload (struct insn_chain *chain, struct reload *rl, int j)
      output-reload, see if we can prove there was
      actually no need to store the old value in it.  */
 
-  if (optimize
+  if (GCC_OPTION (optimize)
       && (reload_inherited[j] || reload_override_in[j])
       && reg_rtx
       && REG_P (reg_rtx)
@@ -8026,7 +8026,7 @@ do_output_reload (struct insn_chain *chain, struct reload *rl, int j)
   reload_reg_rtx_for_output[j] = reg_rtx;
 
   if (pseudo
-      && optimize
+      && GCC_OPTION (optimize)
       && REG_P (pseudo)
       && ! rtx_equal_p (rl->in_reg, pseudo)
       && REGNO (pseudo) >= FIRST_PSEUDO_REGISTER
diff --git a/gcc/reorg.c b/gcc/reorg.c
index 054304a..bb3a61a 100644
--- a/gcc/reorg.c
+++ b/gcc/reorg.c
@@ -2719,7 +2719,7 @@ fill_slots_from_thread (rtx insn, rtx condition, rtx thread,
       if ((GET_CODE (src) == PLUS || GET_CODE (src) == MINUS)
 	  && rtx_equal_p (XEXP (src, 0), dest)
 	  && (!FLOAT_MODE_P (GET_MODE (src))
-	      || flag_unsafe_math_optimizations)
+	      || GCC_OPTION (flag_unsafe_math_optimizations))
 	  && ! reg_overlap_mentioned_p (dest, XEXP (src, 1))
 	  && ! side_effects_p (pat))
 	{
@@ -3868,7 +3868,7 @@ gate_handle_delay_slots (void)
 {
 #ifdef DELAY_SLOTS
   /* At -O0 dataflow info isn't updated after RA.  */
-  return optimize > 0 && flag_delayed_branch && !crtl->dbr_scheduled_p;
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_delayed_branch) && !crtl->dbr_scheduled_p;
 #else
   return 0;
 #endif
diff --git a/gcc/rtl.h b/gcc/rtl.h
index f1cda4c..f8560f0 100644
--- a/gcc/rtl.h
+++ b/gcc/rtl.h
@@ -457,7 +457,7 @@ struct GTY((variable_size)) rtvec_def {
 #define NONDEBUG_INSN_P(X) (INSN_P (X) && !DEBUG_INSN_P (X))
 
 /* Nonzero if DEBUG_INSN_P may possibly hold.  */
-#define MAY_HAVE_DEBUG_INSNS (flag_var_tracking_assignments)
+#define MAY_HAVE_DEBUG_INSNS (GCC_OPTION (flag_var_tracking_assignments))
 
 /* Predicate yielding nonzero iff X is a real insn.  */
 #define INSN_P(X) \
diff --git a/gcc/rtlanal.c b/gcc/rtlanal.c
index 7a9efec..632f858 100644
--- a/gcc/rtlanal.c
+++ b/gcc/rtlanal.c
@@ -2376,7 +2376,7 @@ may_trap_p_1 (const_rtx x, unsigned flags)
       /* Memory ref can trap unless it's a static var or a stack slot.  */
     case MEM:
       /* Recognize specific pattern of stack checking probes.  */
-      if (flag_stack_check
+      if (GCC_OPTION (flag_stack_check)
 	  && MEM_VOLATILE_P (x)
 	  && XEXP (x, 0) == stack_pointer_rtx)
 	return 1;
@@ -2401,7 +2401,7 @@ may_trap_p_1 (const_rtx x, unsigned flags)
       if (HONOR_SNANS (GET_MODE (x)))
 	return 1;
       if (SCALAR_FLOAT_MODE_P (GET_MODE (x)))
-	return flag_trapping_math;
+	return GCC_OPTION (flag_trapping_math);
       if (!CONSTANT_P (XEXP (x, 1)) || (XEXP (x, 1) == const0_rtx))
 	return 1;
       break;
@@ -2418,7 +2418,7 @@ may_trap_p_1 (const_rtx x, unsigned flags)
     case LTGT:
     case COMPARE:
       /* Some floating point comparisons may trap.  */
-      if (!flag_trapping_math)
+      if (!GCC_OPTION (flag_trapping_math))
 	break;
       /* ??? There is no machine independent way to check for tests that trap
 	 when COMPARE is used, though many targets do make this distinction.
@@ -2445,7 +2445,7 @@ may_trap_p_1 (const_rtx x, unsigned flags)
 
     case FIX:
       /* Conversion of floating point might trap.  */
-      if (flag_trapping_math && HONOR_NANS (GET_MODE (XEXP (x, 0))))
+      if (GCC_OPTION (flag_trapping_math) && HONOR_NANS (GET_MODE (XEXP (x, 0))))
 	return 1;
       break;
 
@@ -2457,7 +2457,7 @@ may_trap_p_1 (const_rtx x, unsigned flags)
 
     default:
       /* Any floating arithmetic may trap.  */
-      if (SCALAR_FLOAT_MODE_P (GET_MODE (x)) && flag_trapping_math)
+      if (SCALAR_FLOAT_MODE_P (GET_MODE (x)) && GCC_OPTION (flag_trapping_math))
 	return 1;
     }
 
diff --git a/gcc/sched-ebb.c b/gcc/sched-ebb.c
index ce17214..c5eb95d 100644
--- a/gcc/sched-ebb.c
+++ b/gcc/sched-ebb.c
@@ -410,7 +410,7 @@ add_deps_for_risky_insns (rtx head, rtx tail)
 	  switch (classification)
 	    {
 	    case PFREE_CANDIDATE:
-	      if (flag_schedule_speculative_load)
+	      if (GCC_OPTION (flag_schedule_speculative_load))
 		{
 		  bb = earliest_block_with_similiar_load (last_block, insn);
 		  if (bb)
@@ -628,7 +628,7 @@ schedule_ebbs (void)
   if (n_basic_blocks_for_fn (cfun) == NUM_FIXED_BLOCKS)
     return;
 
-  if (profile_info && flag_branch_probabilities)
+  if (profile_info && GCC_OPTION (flag_branch_probabilities))
     probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY_FEEDBACK);
   else
     probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY);
diff --git a/gcc/sched-rgn.c b/gcc/sched-rgn.c
index dc6fa16..d41cb95 100644
--- a/gcc/sched-rgn.c
+++ b/gcc/sched-rgn.c
@@ -476,7 +476,7 @@ find_single_block_region (bool ebbs_p)
 
   if (ebbs_p) {
     int probability_cutoff;
-    if (profile_info && flag_branch_probabilities)
+    if (profile_info && GCC_OPTION (flag_branch_probabilities))
       probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY_FEEDBACK);
     else
       probability_cutoff = PARAM_VALUE (TRACER_MIN_BRANCH_PROBABILITY);
@@ -1083,7 +1083,7 @@ haifa_find_rgns (void)
 static void
 find_rgns (void)
 {
-  if (sel_sched_p () && flag_sel_sched_pipelining)
+  if (sel_sched_p () && GCC_OPTION (flag_sel_sched_pipelining))
     sel_find_rgns ();
   else
     haifa_find_rgns ();
@@ -1539,7 +1539,7 @@ compute_trg_info (int trg)
 	{
 	  split_edges (i, trg, &el);
 	  sp->is_speculative = (el.nr_members) ? 1 : 0;
-	  if (sp->is_speculative && !flag_schedule_speculative)
+	  if (sp->is_speculative && !GCC_OPTION (flag_schedule_speculative))
 	    sp->is_valid = 0;
 	}
 
@@ -2044,7 +2044,7 @@ is_exception_free (rtx insn, int bb_src, int bb_trg)
     }
 
   /* Handle loads.  */
-  if (!flag_schedule_speculative_load)
+  if (!GCC_OPTION (flag_schedule_speculative_load))
     return 0;
   IS_LOAD_INSN (insn) = 1;
   switch (insn_class)
@@ -2058,14 +2058,14 @@ is_exception_free (rtx insn, int bb_src, int bb_trg)
 	return 1;
       /* Don't 'break' here: PFREE-candidate is also PRISKY-candidate.  */
     case PRISKY_CANDIDATE:
-      if (!flag_schedule_speculative_load_dangerous
+      if (!GCC_OPTION (flag_schedule_speculative_load_dangerous)
 	  || is_prisky (insn, bb_src, bb_trg))
 	return 0;
       break;
     default:;
     }
 
-  return flag_schedule_speculative_load_dangerous;
+  return GCC_OPTION (flag_schedule_speculative_load_dangerous);
 }
 
 /* The number of insns from the current block scheduled so far.  */
@@ -3067,7 +3067,7 @@ schedule_region (int rgn)
 
       target_bb = bb;
 
-      gcc_assert (flag_schedule_interblock || current_nr_blocks == 1);
+      gcc_assert (GCC_OPTION (flag_schedule_interblock) || current_nr_blocks == 1);
       current_sched_info->queue_must_finish_empty = current_nr_blocks == 1;
 
       curr_bb = first_bb;
@@ -3138,7 +3138,7 @@ sched_rgn_init (bool single_blocks_p)
   /* Compute regions for scheduling.  */
   if (single_blocks_p
       || n_basic_blocks_for_fn (cfun) == NUM_FIXED_BLOCKS + 1
-      || !flag_schedule_interblock
+      || !GCC_OPTION (flag_schedule_interblock)
       || is_cfg_nonregular ())
     {
       find_single_block_region (sel_sched_p ());
@@ -3182,7 +3182,7 @@ sched_rgn_finish (void)
   if (sched_verbose)
     {
       if (reload_completed == 0
-	  && flag_schedule_interblock)
+	  && GCC_OPTION (flag_schedule_interblock))
 	{
 	  fprintf (sched_dump,
 		   "\n;; Procedure interblock/speculative motions == %d/%d \n",
@@ -3595,7 +3595,7 @@ static bool
 gate_handle_live_range_shrinkage (void)
 {
 #ifdef INSN_SCHEDULING
-  return flag_live_range_shrinkage;
+  return GCC_OPTION (flag_live_range_shrinkage);
 #else
   return 0;
 #endif
@@ -3609,10 +3609,10 @@ rest_of_handle_live_range_shrinkage (void)
   int saved;
 
   initialize_live_range_shrinkage ();
-  saved = flag_schedule_interblock;
-  flag_schedule_interblock = false;
+  saved = GCC_OPTION (flag_schedule_interblock);
+  GCC_OPTION (flag_schedule_interblock) = false;
   schedule_insns ();
-  flag_schedule_interblock = saved;
+  GCC_OPTION (flag_schedule_interblock) = saved;
   finish_live_range_shrinkage ();
 #endif
   return 0;
@@ -3622,7 +3622,7 @@ static bool
 gate_handle_sched (void)
 {
 #ifdef INSN_SCHEDULING
-  return optimize > 0 && flag_schedule_insns && dbg_cnt (sched_func);
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_schedule_insns) && dbg_cnt (sched_func);
 #else
   return 0;
 #endif
@@ -3633,7 +3633,7 @@ static unsigned int
 rest_of_handle_sched (void)
 {
 #ifdef INSN_SCHEDULING
-  if (flag_selective_scheduling
+  if (GCC_OPTION (flag_selective_scheduling)
       && ! maybe_skip_selective_scheduling ())
     run_selective_scheduling ();
   else
@@ -3646,7 +3646,7 @@ static bool
 gate_handle_sched2 (void)
 {
 #ifdef INSN_SCHEDULING
-  return optimize > 0 && flag_schedule_insns_after_reload
+  return GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_schedule_insns_after_reload)
     && !targetm.delay_sched2 && dbg_cnt (sched2_func);
 #else
   return 0;
@@ -3658,14 +3658,14 @@ static unsigned int
 rest_of_handle_sched2 (void)
 {
 #ifdef INSN_SCHEDULING
-  if (flag_selective_scheduling2
+  if (GCC_OPTION (flag_selective_scheduling2)
       && ! maybe_skip_selective_scheduling ())
     run_selective_scheduling ();
   else
     {
       /* Do control and data sched analysis again,
 	 and write some more of the results to dump file.  */
-      if (flag_sched2_use_superblocks)
+      if (GCC_OPTION (flag_sched2_use_superblocks))
 	schedule_ebbs ();
       else
 	schedule_insns ();
diff --git a/gcc/sdbout.c b/gcc/sdbout.c
index b07824b..4866bda 100644
--- a/gcc/sdbout.c
+++ b/gcc/sdbout.c
@@ -1482,7 +1482,7 @@ sdbout_begin_block (unsigned int line, unsigned int n)
     }
   /* If -g1, suppress all the internal symbols of functions
      except for arguments.  */
-  if (debug_info_level != DINFO_LEVEL_TERSE)
+  if (GCC_OPTION (debug_info_level) != DINFO_LEVEL_TERSE)
     {
       do_block = n;
       sdbout_block (DECL_INITIAL (decl));
